<?php
header('Content-Type: text/html; charset=utf-8');

    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;
    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;

		$outbody = '';
		$outhead = '';
		$outtable = '';
		$graph = array();
		$itemlist = '<ul  class="bl">';
		$i = 0;

require_once("lib/fconnect.php");
$db = DBConnect::getInstance();
$params = $db->colModel->findOne( array('name'=>'chair'));

    require_once("lib/frole.php");
    $role = new Role();

$role->isPageEnable($user->uuid);
$mode='';
if(isset($_GET['mode'])){
	$mode = '&mode='.$_GET['mode'];
}
if(isset($_GET['fak'])){
	$fak = $_GET['fak'];
}
if(isset($_POST['faculty'])){
	$fak = $_POST['faculty'];
}
$faculties = $db->colDocs->find(array('type'=>'faculty'));
$faculties_menu = '
<div class="form-group">
<form method="post" class="form-inline" action="chairsbyparams.php">
Выбрать факультет: <select class="form-control" name="faculty">
<!--option>Выбрать</option>-->';
foreach($faculties as $faculty){
	if(isset($fak) && $faculty['uuid'] == $fak){
			$selected = ' selected';
			$faktitle = $faculty['title_ru'];
	}else{
			$selected = '';
	}
	$faculties_menu .= '
	<option value="'.$faculty['uuid'].'"'.$selected.'>'.$faculty['title_ru'].'</option>';

}
$faculties_menu .='
</select>
<input class="btn btn-default" type="submit" value="Применить!">
</form>
</div>';

$subtext='';
foreach($params['items'] as $item){
	if(isset($item['pdf']) && $item['pdf']){
		if(isset($item['type'])){
			if($item['type'] == 'section'){$itemlist .= '<li>Раздел '.++$i.': <b>'.$item['label_ru'].'</b></li>';}
			elseif($item['type'] == 'subsection'){$subtext = $item['label_ru'];}
			else{
				if(isset($faktitle)){
					$fakbutton = '<a href="?item='.$item['name'].$mode.'&fak='.$fak.'#container" class="bt gray">'.$faktitle.'</a>';
				}else{
					$fakbutton = '';
				}
				$itemlist .= '<li>
				<a href="?item='.$item['name'].$mode.'#container" class="bt blue">Все</a>
				<a href="?item='.$item['name'].$mode.'&first=10#container" class="bt blue">Топ10</a>
				<a href="?item='.$item['name'].$mode.'&type=E#container" class="bt green">Е</a>
				<a href="?item='.$item['name'].$mode.'&type=G#container" class="bt red">G</a>
				<a href="?item='.$item['name'].$mode.'&type=T#container" class="bt brown">T</a>
				<a href="?item='.$item['name'].$mode.'&type=P#container" class="bt violet">P</a>
				'.$fakbutton.'
				'.$subtext.' '.$item['label_ru'].'
				</li>';}
			if(isset($_GET['item']) && $_GET['item']==$item['name']){
				$title = addcslashes($subtext.' '.$item['label_ru'], "'");
				$title = addcslashes($title, '"');
				if($item['accumulative']){$accFlag = true; $description ='накопительный параметр';}else{$accFlag = false;$description ='ненакопительный параметр';}
			}
		}
	}
}

//Отлов значений
$rates = 1;
if(isset($_GET['item'])){
	if(isset($_GET['type'])){
		switch($_GET['type']){
	case 'E':
		$what = array('type'=>'chair','chairtype'=>'E');
		$plotcolor = '#699954';
		$heading = 'Кафедры естественнонаучного профиля';
	break;
	case 'G':
		$what = array('type'=>'chair','chairtype'=>'G');
		$plotcolor = '#A75C69';
		$heading = 'Рейтинг кафедр гуманитарного профиля';
	break;
	case 'T':
		$what = array('type'=>'chair','chairtype'=>'T');
		$plotcolor = '#B29162';
		$heading = 'Кафедры творческого профиля';
	break;
	case 'P':
		$what = array('type'=>'chair','chairtype'=>'P');
		$plotcolor = '#90708C';
		$heading = 'Кафедры педагогического профиля';
	break;
	default:
		$what = array('type'=>'chair');
		$plotcolor = '#435C73';
		$heading = 'Кафедры университета';
		}
	}else{
		$what = array('type'=>'chair');
		$plotcolor = '#435C73';
		$heading = 'Кафедры университета';
	}
if(isset($fak)){
	$what = array('type'=>'chair','parent'=>$fak);
	$plotcolor = '#555';
	$heading = $faktitle;
}
	$docs = $db->colDocs->find($what);
	//$thisItem = $db->colModel->findOne( array('name'=>'chair'));
	if($accFlag){
		foreach($docs as $doc){
			if(isset($doc[$_GET['item']])){
				if(isset($_GET['mode']) && $_GET['mode']=='relative'){
					if(isset($doc['rates']) && $doc['rates']>0){
						$rates = (float)$doc['rates'];
					}else{
						die('Ошибка подсчета ставок у кафедры'.$doc['title_ru']);
					}
				}
			$data['pure'][$doc['uuid']] = round((float)$doc[$_GET['item']]/$rates,3);
			//$data['k100'][$doc['title_ru']] = (float)$doc[$_GET['item']];
			}
		}
	}else{
		foreach($docs as $doc){
			if(isset($_GET['mode']) && $_GET['mode']=='relative'){
				if(isset($doc['rates']) && $doc['rates']>0){
					$rates = (float)$doc['rates'];
				}else{
					die('Ошибка подсчета ставок у кафедры'.$doc['title_ru']);
				}
			}
			$data['pure'][$doc['uuid']] = 0;
			if (isset($doc['versions'])) {
				foreach($doc['versions'] as $version){
					if(isset($version['content'][$_GET['item']])){
						$data['pure'][$doc['uuid']] += round((float)$version['content'][$_GET['item']]/$rates,3);
					}
				}
			}
			if(isset($doc[$_GET['item']])){
				$data['pure'][$doc['uuid']] += (float)$doc[$_GET['item']]/$rates;
			}
		}
	}
	arsort($data['pure']);

foreach($data['pure'] as $key => $value){
	$chair = $db->colDocs->findOne(array('uuid'=>$key));
	if(!isset($periods)){
		$periods = ((isset($chair['versions']) && is_array($chair['versions'])) ? count($chair['versions']) : 0) + 1;
		$periodCells = '';
		for($i=1;$i<=$periods;$i++){
			$periodCells .= '<td><b>'.$i.'</b></td>';
		}
	}
	$titlesArr[] = "'".$chair['title_ru']."'";
	$verCells = '';
    if (isset($chair['versions']) && is_array($chair['versions'])) {
    	foreach($chair['versions'] as $version){
    		if(isset($version['content'][$_GET['item']])){
    			$verCells .='<td>'.$version['content'][$_GET['item']].'</td>';
    		}
    	}
    }
	$tableArr[]= '<tr>
	<td>'.$chair['title_ru'].'</td>'.$verCells.'<td>'.(isset($chair[$_GET['item']]) ? $chair[$_GET['item']] : '').'</td>
	</tr>';
	$valuesArr[] = $value;


}


	if(isset($_GET['first']) && $_GET['first']=='10'){
	$titlesArr = array_slice($titlesArr,0,10);
	$tableArr  = array_slice($tableArr,0,10);
	$valuesArr = array_slice($valuesArr,0,10);
	}
	//var_dump(count($tableArr));
	$plotheight = 200 + 60*count($valuesArr).'px';

$titles = implode(', ', $titlesArr);
$values = implode(', ', $valuesArr);

$outtable = '<table id="tdata">
<tr><th></th><th colspan="'.$periods.'">периоды</th></tr>
<tr><td><b>'.$title.'</b></td>'.$periodCells.'</tr>
'.implode(' ', $tableArr).'
</table>';
$outhead = "

<script>
$(function () {
    $('#container').highcharts({
        exporting:{
			enabled: false
		},
		chart: {
            type: 'bar'
        },
        colors:['".$plotcolor."'],
        title: {
            text: '".$heading."'
        },
        subtitle: {
            text: '".$title."(".$description.")'
        },
        xAxis: {
            categories: [".$titles."],
                title: {
                text: null
            },
            labels: {
                overflow: 'justify',
                 style: {
                 fontSize: '12px',
            color: '#000'
         }
            }

        },
        yAxis: {
            min: 0,
            title: {
                text: '',
                align: 'high'
            },

            labels: {
                overflow: 'justify',
                 style: {
                 fontSize: '15px',
            color: '#000'
         }
            }
        },
        tooltip: {
            valueSuffix: ''
        },
        plotOptions: {
            bar: {
                dataLabels: {
                    enabled: true
                }
            }
        },
        legend: {
            layout: 'vertical',
            enable: false,
            align: 'right',
            verticalAlign: 'bottom',
            x: -40,
            y: 100,
            floating: true,
            borderWidth: 1,
            backgroundColor: ((Highcharts.theme && Highcharts.theme.legendBackgroundColor) || '#FFFFFF'),
            shadow: true
        },
        credits: {
            enabled: false
        },
        series: [{
            name: 'значения',
            data: [".$values."]
        }]
    });
});
</script>
";

}

$itemlist .= '</ul>';
$outbody .= $itemlist;
?>
<!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Ранжирование кафедр</title>
<link rel="stylesheet" href="/css/jquery-ui.css" />

<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>
<script src="/js/bootstrap.min.js"></script>

<script src="/js/highcharts/highcharts.js"></script>
<script src="/js/highcharts/highcharts-more.js"></script>
<script src="/js/highcharts/modules/exporting.js"></script>

<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />
<link rel="stylesheet" href="/css/units.css" />
<link rel="stylesheet" href="/css/colors.css">
<link rel="stylesheet" href="/css/buttons.css">
<script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";
  </script>
<?=$outhead?>
<style>
table#tdata, table#tdata td{border:1px solid #ccc;padding:2px 5px;margin:30px;}
ul.bl{ list-style-type:none;}
ul.bl li{display:inline-block; border:1px dotted #555;margin:1px; width:100%;padding:5px 10px;}
a.scrolltotop{
position:fixed; bottom:30px; right:30px;
}
</style>
</head>

<body>
<A class="scrolltotop btn btn-info" href="javascript:void(0)"
   onclick="scroll(0,0)">вверх</A>

<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Ранжирование кафедр
    </h1>

    <h2 class="header__headings__subheading">
        По показателям комплексного рейтинга кафедр РГПУ им. А.И. Герцена
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div class = "left">
	<?php
echo $role->userMenu($user->uuid);
	?>
</div>
<!-- CURRENT PAGE -->
<div class="all">
	<div><!--a href="?mode=basic"><button class="btn">Абсолютные значения</button></a-->
<?=$faculties_menu?>
<?=$outbody?>
<div id="container" style="min-width: 900px; max-width: 1200px; height: <?=$plotheight?>; margin: 0 auto"></div>
<div id="data">
<?=$outtable?>
</div>
</div>
</body>
</html>
